proyecto-taller-info/config/routes.rb
Rails.application.routes.draw do

  resources :people
  devise_for :users

  resources :users
  resources :companies
  resources :projects
  resources :legal_agents

  get '' => 'static_pages#home'
  get '/users/annul/:id' => 'users#annul'
  get '/users/activate/:id' => 'users#activate'
  get 'error' => 'static_pages#error'
  post '/createuser' => 'users#create'

end

proyecto-taller-info/app/models/person.rb
class Person < ActiveRecord::Base
  belongs_to :user

  validates :identification_number, presence: {:message => ' no debe dejarse en blanco.'}
  validates :identification_number, uniqueness: {:message => '  no debe repetirse.'}
  validates :identification_number, numericality: { only_integer: true, message: ' debe ser un numero' }
  # validates :identification_number, :presence => true, :uniqueness => {:scope => :identification_type}
  # validates :identification_type, presence: {:message => ' (Tipo de identificacion) no debe dejarse en blanco.'}
  # validates :identification_number, uniqueness: { scope: [:identification_type] }
  validates :firs_name, presence: {:message => '  no debe dejarse en blanco.'}
  validates :last_name, presence: {:message => '  no debe dejarse en blanco.'}
  validates :country, presence: {:message => '  no debe dejarse en blanco.'}
  validates :city, presence: {:message => '  no debe dejarse en blanco.'}
  validates :address, presence: {:message => '   no debe dejarse en blanco.'}
  validates :email, presence: {:message => ' no debe dejarse en blanco.'}
  validates :position, presence: {:message => '  no debe dejarse en blanco.'}
  validates :profession, presence: {:message => ' no debe dejarse en blanco.'}
  validates :email, uniqueness: {:message =>' ya existe'}
  validates :email, format: { with: /\A([^@\s]+)@((?:[-a-z0-9]+\.)+[a-z]{2,})\z/i, on: :create, message: 'es invalido'}

  def self.search(search)
    where('firs_name LIKE :search OR last_name LIKE :search', search:"%#{search}%")
  end

end

proyecto-taller-info/app/controllers/people_controller.rb
class PeopleController < ApplicationController
  before_action :set_person, only: [:show, :edit, :update, :destroy]

  # GET /people
  # GET /people.json
  def index
    @people = Person.all

    if params[:search]
      @people = Person.search(params[:search]).order('created_at DESC')
    else
      @people = Person.all.order('created_at ASC')
    end
  end

  # GET /people/1
  # GET /people/1.json
  def show
  end

  # GET /people/new
  def new
    @person = Person.new
    @users = User.all
  end

  # GET /people/1/edit
  def edit
    @users = User.all
  end

  # POST /people
  # POST /people.json
  def create
    @person = Person.new(person_params)
    @users = User.all
    respond_to do |format|
      if @person.save
        format.html { redirect_to @person, notice: 'Person was successfully created.' }
        format.json { render :show, status: :created, location: @person }
      else
        format.html { render :new }
        format.json { render json: @person.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /people/1
  # PATCH/PUT /people/1.json
  def update
    respond_to do |format|
      if @person.update(person_params)
        format.html { redirect_to @person, notice: 'Person was successfully updated.' }
        format.json { render :show, status: :ok, location: @person }
      else
        format.html { render :edit }
        format.json { render json: @person.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /people/1
  # DELETE /people/1.json
  def destroy
    @person.destroy
    respond_to do |format|
      format.html { redirect_to people_url, notice: 'Person was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_person
      @person = Person.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def person_params
      params.require(:person).permit(:identification_number, :identification_type, :firs_name, :last_name, :country, :city, :address, :email, :profession, :position, :user_id)
    end
end

proyecto-taller-info/app/helpers/people_helper.rb
module PeopleHelper
end

proyecto-taller-info/app/views/people/_form.html.erb
<%= form_for(@person) do |f| %>
  <% if @person.errors.any? %>
    <div id="error_explanation">
      <h2>Errores</h2>

      <ul>
      <% @person.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <br>
    <label>Numero de identificacion</label>
    <%= f.number_field :identification_number, class: 'form-control' %>
  </div>
  <!--<div class="field">-->
    <!--<br>-->
    <!--<label>Tipo de identificacion</label>-->
    <!--<select name='person[identification_type]' class="form-control">-->
      <!--<option value="1">Carnet de Identidad</option>-->
      <!--<option value="2">Libreta Militar</option>-->
      <!--<option value="3">Pasaporte</option>-->
    <!--</select>-->
  <!--</div>-->
  <div class="field">
    <br>
    <label>Nombre</label>
    <%= f.text_field :firs_name, class: 'form-control' %>
  </div>
  <div class="field">
    <br>
    <label>Apellido</label>
    <%= f.text_field :last_name, class: 'form-control' %>
  </div>
  <div class="field">
    <br>
    <label>Pais</label>
    <%= f.text_field :country, class: 'form-control' %>
  </div>
  <div class="field">
    <br>
    <label>Ciudad</label>
    <%= f.text_field :city, class: 'form-control' %>
  </div>
  <div class="field">
    <br>
    <label>Direccion</label>
    <%= f.text_field :address, class: 'form-control' %>
  </div>
  <div class="field">
    <br>
    <label>Email</label>
    <%= f.text_field :email, class: 'form-control' %>
  </div>
  <div class="field">
    <br>
    <label>Profesion</label>
    <%= f.text_field :profession, class: 'form-control' %>
  </div>
  <div class="field">
    <br>
    <label>Posicion de trabajo</label>
    <%= f.text_field :position, class: 'form-control' %>
  </div>
  <div class="field">
    <br>
    <label>Usuario</label>
    <%= f.select :user_id, options_from_collection_for_select(@users, 'id', 'username'),{}, :prompt => 'Ninguno' , :class => 'form-control'%>
  </div>
  <br>
  <div class="actions">
    <%= f.submit 'Guardar', class: 'btn btn-default' %>
  </div>
<% end %>

proyecto-taller-info/app/views/people/edit.html.erb
<h1>Editar Persons</h1>

<div class="col-md-6">
  <%= render 'form' %>
</div>

<!--<%= link_to 'Show', @person %> |
<%= link_to 'Back', people_path %>-->

proyecto-taller-info/app/views/people/index.html.erb
<!--<p id="notice"><%= notice %></p>-->

<h1>Personal</h1>

<table class="table">
  <thead>
    <tr>
      <th>Numero de identificacion</th>
      <!--<th>Tipo de identidicacion</th>-->
      <th>Nombre</th>
      <th>Apellido</th>
      <th>Pais</th>
      <th>Ciudad</th>
      <th>Direccion</th>
      <th>Email</th>
      <th>Profesion</th>
      <th>Posicion</th>
      <th>Usuario</th>
      <th colspan="2"></th>
    </tr>
  </thead>

  <tbody>
    <% @people.each do |person| %>
      <tr>
        <td><%= person.identification_number %></td>
        <!--<td><%= person.identification_type %></td>-->
        <td><%= person.firs_name %></td>
        <td><%= person.last_name %></td>
        <td><%= person.country %></td>
        <td><%= person.city %></td>
        <td><%= person.address %></td>
        <td><%= person.email %></td>
        <td><%= person.profession %></td>
        <td><%= person.position %></td>
        <td><%= if person.user then person.user.username else 'Ninguno' end %></td>
        <td><%= link_to 'Ver', person, class: 'btn btn-default' %></td>
        <td><%= link_to 'Editar', edit_person_path(person), class: 'btn btn-primary' %></td>
        <!--<td><%= link_to 'Destroy', person, method: :delete, data: { confirm: 'Are you sure?' } %></td>-->
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<!--<%= link_to 'New Person', new_person_path %>-->

<%= form_tag( people_path , :method => "get", id: "search-form") do %>
    <%= text_field_tag :search, params[:search], placeholder: "Buscar personas" %>
    <%= submit_tag "Buscar" %>
<% end %>

<% if @legal_agents.present? %>
    <%= render :partial => 'people/search' %>
<% else %>
    <p>No existe personal para el criterio de busqueda <%= params[:search] %></p>
<% end %>

proyecto-taller-info/app/views/people/new.html.erb
<h1>Registrar Personal</h1>

<div class="col-md-6">
  <%= render 'form' %>
</div>

<!--<%= link_to 'Back', people_path %>-->

proyecto-taller-info/app/views/people/show.html.erb
<!--<p id="notice"><%= notice %></p>-->

<p>
  <strong>Numero de identificacion:</strong>
  <%= @person.identification_number %>
</p>

<!--<p>-->
  <!--<strong>Tipo de indentificacion: </strong>-->
  <!--<% if @person.identification_type == 1 %>-->
      <!--Carnet de Identidad-->
  <!--<% elsif @person.identification_type == 2 %>-->
      <!--Libreta Militar-->
  <!--<% else %>-->
      <!--Passaporte-->
  <!--<% end %>-->
<!--</p>-->

<p>
  <strong>Nombre:</strong>
  <%= @person.firs_name %>
</p>

<p>
  <strong>Apellido:</strong>
  <%= @person.last_name %>
</p>

<p>
  <strong>Pais:</strong>
  <%= @person.country %>
</p>

<p>
  <strong>Ciudad:</strong>
  <%= @person.city %>
</p>

<p>
  <strong>Direccion:</strong>
  <%= @person.address %>
</p>

<p>
  <strong>Email:</strong>
  <%= @person.email %>
</p>

<p>
  <strong>Profesion:</strong>
  <%= @person.profession %>
</p>

<p>
  <strong>Posicion:</strong>
  <%= @person.position %>
</p>

<p>
  <strong>Usuario:</strong>
  <%= if @person.user then @person.user.username else '' end %>
</p>

<!--<%= link_to 'Edit', edit_person_path(@person) %>-->
<!--<%= link_to 'Back', people_path %>-->